﻿using UnityEngine;
using System.Collections;

public class AudioManager : MonoBehaviour {

    AudioSource musicManager;
    AudioSource soundEffectManager;
    public AudioClip battleMusic;
    public AudioClip menuMusic;
    public AudioClip playerAttack;
    public AudioClip friendAttack;
    public AudioClip enemyAttack;
    string tempState;
    bool battleState;
    int audioControl;

    public static AudioManager instance; 
        void Awake()
    {
        musicManager = GetComponent<AudioSource>();
        soundEffectManager = GetComponent<AudioSource>();
        battleState = true;
        instance = this;
        audioControl = 0;
    }

    void Start()
    {
        tempState = ""; 
    }

    
    void FixedUpdate()
    {

        if ((tempState != StateManager.instance.currentState.ToString()))
        {
            PlayMusic();
        }

    }


    void PlayMusic()
    {
        tempState = StateManager.instance.currentState.ToString();
        print(tempState);
        musicManager.volume = 0.8f;

        if (tempState == "Battle")
        {
            battleState = true;
            musicManager.volume -= 1 * Time.deltaTime;
            musicManager.Stop();
            musicManager.PlayOneShot(battleMusic, 1);
        }
        else if (tempState == "Conversation" || tempState == "Sacrifice")
        {
           
            musicManager.volume -= 1 * Time.deltaTime;
            if (battleState)
            {
                musicManager.Stop();
                musicManager.PlayOneShot(menuMusic, 1);
            }
                battleState = false;
        }
        else
        {
            musicManager.Stop();
        }


    }

    public void PlayEffect(int n)
    {
        //1 player, 2 friend, 3 enemy
        audioControl++;

        if (audioControl > 15)
        {
            switch (n)
            {

                case 1:
                    {
                        int ran = Random.Range(1, 2);
                        if(ran == 1)
                        musicManager.PlayOneShot(playerAttack, 1);
                        else
                        musicManager.PlayOneShot(friendAttack, 1);
                        break;
                    }
                case 2:
                    {

                        musicManager.PlayOneShot(enemyAttack, 1);
                        break;
                    }
                default:
                    break;
            }
            audioControl = 0;
        }
    }


}
