﻿using UnityEngine;
using System.Collections;

public class Character : MonoBehaviour, IDamagable
{

    public float health;
    public CHARTYPE charType;
    public ParticleSystem deathEffect;

    void Awake()
    {
        deathEffect = GetComponent<ParticleSystem>();
    }


    public void TakeDamage(float damage)
    {
        deathEffect.Play();
        health -= damage;
    }

    void LateUpdate()
    {
        if (health < 0)
        {
            deathEffect.Play();
            Destroy(gameObject);
        }
    }

    void BloodSpill()
    {
        gameObject.transform.FindChild("DeathEffect").gameObject.SetActive(true);
    }
}
