﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class GameManager : MonoBehaviour
{

    public GameObject player;
    public GameObject playerTeam;
    public GameObject enemyTeam;
    Vector3 playerPos;
    float tempPosZ;
    public BattleConfig battleConfig;
    //public EnemyTeam enemyTeamConfig;
    //public PlayerTeam playerTeamConfig;
    public int playerCount;
    public int enemyCount;
    public BattleGround battleGround;
   

    public static GameManager Instance;



    public GameObject mainCamera;







    void Awake()
    {
        Instance = this;
        playerCount = battleConfig.playerCount + 1;   //the player itself
        enemyCount = battleConfig.enemyCount;

        List<Transform> playerList = new List<Transform>();
        List<Transform> enemyList = new List<Transform>();
        playerPos = new Vector3(-20, 0f, 0);
        var playerController = (Instantiate(player, playerPos, Quaternion.Euler(0, 90, 0)) as GameObject).GetComponent<PlayerController>();
        playerController.Init(battleConfig.playerSpeed,
            battleConfig.playerHealth,
            battleConfig.playerDamage,
            0.5f
        );

        //mainCamera.transform.parent = playerController.transform;

        playerList.Add(playerController.transform);

        tempPosZ = -23.0f;

        for (int i = 1; i <= battleConfig.playerCount; i++)
        {
            var p = (Instantiate(playerTeam, new Vector3(-22, 0, tempPosZ), Quaternion.Euler(0, 90, 0)) as GameObject).transform;
            p.name = "player" + i;
            tempPosZ += battleGround.arenaWidthX / battleConfig.playerCount;
            playerList.Add(p);
        }

        tempPosZ = -23.0f;
        for (int i = 1; i <= battleConfig.enemyCount; i++)
        {
            var p = (Instantiate(enemyTeam, new Vector3(22, 0, tempPosZ), Quaternion.Euler(0, 270, 0)) as GameObject);
            p.name = "enemy" + i;
            var q = p.GetComponent<EnemyController>();
            tempPosZ += battleGround.arenaWidthX / battleConfig.enemyCount;
            ;
            enemyList.Add(p.transform);
        }

        for (int i = 0; i < enemyList.Count; i++)
        {
            enemyList[i].GetComponent<EnemyController>().Init(5, 10, 2, 1, playerList);
        }
        for (int j = 0; j < playerList.Count; j++)
        {
            var p = playerList[j].GetComponent<EnemyController>();
            if (p != null)
            {
                p.Init(5, 10, 2, 1, enemyList);
            }
        }
        
    }

    public void KillGame()
    {

    }

    public void ResetGame()
    {

    }

    
}
