﻿using UnityEngine;
using System.Collections;

public class PlayerController : Character
{
    public float rotationSpeed;
    public float movementSpeed;
    public float damage;
    public float fireRate;

    Transform playerTransform;
    Rigidbody playerBody;
    public WeaponControl weapon;

    bool initialized = false;

    public CHARTYPE hostile;

    void Awake()
    {
        playerTransform = GetComponent<Transform>();
        playerBody = GetComponent<Rigidbody>();
        initialized = false;
        charType = CHARTYPE.Friend;
    }

    public void Init(float playerSpeed, float playerHealth, float playerDamage, float fire)
    {
        initialized = true;
        rotationSpeed = rotationSpeed;
        movementSpeed = playerSpeed;
        health = playerHealth;
        damage = playerDamage;
        fireRate = fire;
        weapon.Init(damage, fireRate, hostile);
    }

    void FixedUpdate()
    {
        if (initialized)
        {
            playerBody.velocity = Vector3.zero;
            if (Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.UpArrow))
            {
                playerBody.velocity = transform.forward * movementSpeed * Time.deltaTime;
                ;
            }
            else if (Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.DownArrow))
            {
                playerBody.velocity = transform.forward * -movementSpeed * Time.deltaTime;
            }

            if (Input.GetKey(KeyCode.A) || Input.GetKey(KeyCode.LeftArrow))
            {
                playerTransform.Rotate(Vector3.up * -rotationSpeed * Time.deltaTime);
            }
            else if (Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.RightArrow))
            {
                playerTransform.Rotate(Vector3.up * rotationSpeed * Time.deltaTime);
            }

            if (Input.GetKey(KeyCode.Space) || (Input.GetMouseButton(0)))
            {
                weapon.Attack();
            }

        }
    }
}
