﻿using UnityEngine;
using System.Collections;

public class PlayerManager : MonoBehaviour {

    public float rotationSpeed;
    public float movementSpeed;
    public float health;
    public float damage;

    Transform playerTransform;
    Rigidbody playerBody;

    bool initialized = false;
    bool isAttacking = false;
   

    public static PlayerManager Instance;

    void Awake()
    {
        Instance = this;
        playerTransform = GetComponent<Transform>();
        playerBody = GetComponent<Rigidbody>();
        transform.GetChild(1).gameObject.SetActive(false);
    }


    public void Init(float playerSpeed, float playerHealth, float playerDamage)
    {
        initialized = true;
        rotationSpeed = rotationSpeed * Time.deltaTime;
        movementSpeed = playerSpeed * Time.deltaTime;
        health = playerHealth;
        damage = playerDamage;
    }


    void FixedUpdate()
    {
        if (initialized)
        {

            if (Input.GetKey(KeyCode.W))
            {
                playerBody.velocity = transform.forward * movementSpeed;
            }
            else if (Input.GetKey(KeyCode.S))
            {
                playerBody.velocity = transform.forward * -movementSpeed;
            }

            if (Input.GetKey(KeyCode.A))
            {
                playerTransform.Rotate(Vector3.up * -rotationSpeed);
            }
            else if (Input.GetKey(KeyCode.D))
            {
                playerTransform.Rotate(Vector3.up * rotationSpeed);
            }
            
            if (Input.GetKeyDown(KeyCode.Space))
            {
                transform.GetChild(1).gameObject.SetActive(true);
                isAttacking = true;
                StartCoroutine("AttackAnim", 0);
            }

        }

        if (health <= 0)
        {
            GameManager.Instance.KillGame();
        }

    }


    IEnumerator AttackAnim()
    {
        yield return new WaitForSeconds(0.5f);
        isAttacking = false;
        transform.GetChild(1).gameObject.SetActive(false);
    }

    //void OnTriggerEnter(Collider hit)
    //{
    //    if(isAttacking && hit.gameObject.tag == "EnemyTeam")
    //    {
    //        hit.gameObject.GetComponent<CollionManager>().health -= damage;
    //    }
    //}

    
}
