﻿using UnityEngine;
using System.Collections;
using DG.Tweening;

public class WeaponControl : MonoBehaviour
{

    float attackDamage;
    float fireRate;
    CHARTYPE whoToDamage;
    Character c;
    float timeForNextAttack = 0;

    bool isAttacking = false;

    public float attackTime = 0.3f;
    float lastAttackTime;

    public float maxMoveTo = 0.7f;
    public float minMoveTo = 0.2f;
    public float movementTime = 0.5f;

    int n = 0;


    public void Init(float damage, float fire, CHARTYPE other)
    {
        attackDamage = damage;
        whoToDamage = other;
        fireRate = fire;
        timeForNextAttack = Time.time;
        isAttacking = false;
    }

    public void Attack()
    {
        if (timeForNextAttack < Time.time)
        {
            timeForNextAttack = Time.time + fireRate;
            lastAttackTime = Time.time;
            isAttacking = true;
            var seq = DOTween.Sequence();
            seq.Append(transform.DOLocalMoveZ(maxMoveTo, movementTime / 2));
            seq.Append(transform.DOLocalMoveZ(minMoveTo, movementTime / 2));
        }
    }

    void FixedUpdate()
    {
        if (isAttacking && Time.time > lastAttackTime + attackTime)
        {
            isAttacking = false;
        }
    }

    void OnTriggerEnter(Collider collider)
    {
        c = collider.GetComponent<Character>();
        if (c != null && c.charType == whoToDamage)
        {
            c.TakeDamage(attackDamage);
            if (c.charType == CHARTYPE.Friend)
                n = 1;
            else 
                n = 2;
           AudioManager.instance.PlayEffect(n);
        }
    }
}
